deg2rad = 3.14159265358979/180.0

-- ears are drawn as reflections across the x=0 axis.
--  they just touch the face.
function draw_ear ( angle, face, ear )
  begin_subassembly()
    rotate_z ( angle * deg2rad )
    translate( face + ear, 0, 0 )
    circle( ear, 1, 1)
  end_subassembly()
end

function draw_ears(angle, face, ear )
  draw_ear ( 90 - angle / 2, face, ear )
  draw_ear ( 90 + angle / 2, face, ear )
end

-- eyes are also reflected across the x=0 axis
function draw_eyes ( y, sep, eye )
  begin_subassembly()
    translate(-sep/2, y, 0)
    circle( eye, 1, 0 )
    translate( sep, 0, 0)
    circle( eye, 1, 0 )
  end_subassembly()
end

-- the smile is drawn as a transparent ellipse almost covering
-- an opaque ellipse.  the transparent must be drawn first.
function draw_mouth (y, a, b, sep )
  begin_subassembly()
  translate(0, y, 0)
  ellipse( a , b , 1, 1)

  translate(0, -sep, 0)
  ellipse( a , b , 1, 0)
  end_subassembly()
end

face = 5
ear = 3.5

-- the overall scheme is to draw the opaque "cut outs" first:
-- the eyes, the nose, and the mouth.  then we accept all of the
-- rays through the face and ear apertures
begin_assembly()

draw_eyes( 1, 4, 1 )

draw_ears( 80, face, ear )

-- nose
begin_subassembly()
  translate(0, -1, 0)
  circle( 0.7, 1, 0 )
end_subassembly()

draw_mouth( -1, 2.5, 2, 0.5 )

circle( face, 1, 1 )

end_assembly()
