#ifndef ASSEMBLY_QUEUE_H
#define ASSEMBLY_QUEUE_H

/* --8<--8<--8<--8<--
 *
 * Copyright (C) 2006 Smithsonian Astrophysical Observatory
 *
 * This file is part of aperture
 *
 * aperture is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * aperture is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the 
 *       Free Software Foundation, Inc. 
 *       51 Franklin Street, Fifth Floor
 *       Boston, MA  02110-1301, USA
 *
 * -->8-->8-->8-->8-- */

#include "assembly.h"

unsigned long get_assembly_id( void );

void assembly_queue_cleanup( void );
void assembly_queue_register_lua( lua_State *L );
void assembly_queue_init( void* udata );
size_t assembly_queue_napertures( void );

AssemblyArray* assembly_queue_array_new( size_t* n_assemblies );
void assembly_queue_array_free( size_t n_assemblies, AssemblyArray* array );
#endif /* !ASSEMBLY_QUEUE_H */
